def make_fista( grad, proximal, l ):

   @profile
   def fista( x ):

      # If first iteration, initialize:
      if not hasattr( fista, "y" ):
         fista.y = x.copy()
      if not hasattr( fista, "t" ):
         fista.t = 1.0

      # Record previous iterate:
      fista.prev_x = x.copy()
      # Move along:
      x = proximal( fista.y - l * grad( fista.y ) )

      # Record previous_t:
      fista.prev_t = float( fista.t )
      # Update t:
      fista.t = 0.5 * ( 1.0 + ( 1.0 + 4.0 * fista.t ** 2.0 ) ** 0.5 )

      # update y:
      fista.y = x + ( ( fista.prev_t - 1.0 ) / fista.t ) * ( x - fista.prev_x )

      return x

   return fista
